"""result-output

Revision ID: 1f5969a92b85
Revises: 6634396f139a
Create Date: 2025-03-07 05:18:25.027730

"""

from collections.abc import Sequence
from typing import Union

import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision: str = "1f5969a92b85"
down_revision: Union[str, None] = "6634396f139a"
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "metric_execution_result_output",
        sa.Column("id", sa.Integer(), nullable=False),
        sa.Column("metric_execution_result_id", sa.Integer(), nullable=False),
        sa.Column("output_type", sa.Enum("Plot", "Data", "HTML", name="resultoutputtype"), nullable=False),
        sa.Column("filename", sa.String(), nullable=True),
        sa.Column("short_name", sa.String(), nullable=True),
        sa.Column("long_name", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.Column("created_at", sa.DateTime(), server_default=sa.text("(CURRENT_TIMESTAMP)"), nullable=False),
        sa.Column("updated_at", sa.DateTime(), server_default=sa.text("(CURRENT_TIMESTAMP)"), nullable=False),
        sa.ForeignKeyConstraint(
            ["metric_execution_result_id"],
            ["metric_execution_result.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    with op.batch_alter_table("metric_execution_result_output", schema=None) as batch_op:
        batch_op.create_index(
            batch_op.f("ix_metric_execution_result_output_metric_execution_result_id"),
            ["metric_execution_result_id"],
            unique=False,
        )
        batch_op.create_index(
            batch_op.f("ix_metric_execution_result_output_output_type"), ["output_type"], unique=False
        )

    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table("metric_execution_result_output", schema=None) as batch_op:
        batch_op.drop_index(batch_op.f("ix_metric_execution_result_output_output_type"))
        batch_op.drop_index(batch_op.f("ix_metric_execution_result_output_metric_execution_result_id"))

    op.drop_table("metric_execution_result_output")
    # ### end Alembic commands ###
